<html>
<head>
<title>OGRE: Ogre::Plane Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li class="current"><a href="classes.html"><span>Classes</span></a></li>
    <li><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="tabs">
  <ul>
    <li><a href="classes.html"><span>Alphabetical&nbsp;List</span></a></li>
    <li><a href="annotated.html"><span>Class&nbsp;List</span></a></li>
    <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
    <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="namespaceOgre.html">Ogre</a>::<a class="el" href="classOgre_1_1Plane.html">Plane</a></div>
<h1>Ogre::Plane Class Reference</h1><!-- doxytag: class="Ogre::Plane" -->Defines a plane in 3D space.  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="OgrePlane_8h-source.html">OgrePlane.h</a>&gt;</code>
<p>
<div class="dynheader">
Inheritance diagram for Ogre::Plane:</div>
<div class="dynsection">
<center><font size="2">[<a href="graph_legend.html">legend</a>]</font></center></div>

<p>
<a href="classOgre_1_1Plane-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Types</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">enum &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plane.html#a5d44b14d6f032f3e0a26e83589180bc">Side</a> { <a class="el" href="classOgre_1_1Plane.html#a5d44b14d6f032f3e0a26e83589180bcad112821a6c39f0097136ba5df53052a">NO_SIDE</a>, 
<a class="el" href="classOgre_1_1Plane.html#a5d44b14d6f032f3e0a26e83589180bcc5f2b56ac439b77aad6dfc4031891be5">POSITIVE_SIDE</a>, 
<a class="el" href="classOgre_1_1Plane.html#a5d44b14d6f032f3e0a26e83589180bcaf227c36d02442779fd4600d00580f5e">NEGATIVE_SIDE</a>, 
<a class="el" href="classOgre_1_1Plane.html#a5d44b14d6f032f3e0a26e83589180bc44420e1c49338ae721f298826e164935">BOTH_SIDE</a>
 }</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">The "positive side" of the plane is the half space to which the plane normal points.  <a href="classOgre_1_1Plane.html#a5d44b14d6f032f3e0a26e83589180bc">More...</a><br></td></tr>
<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plane.html#1530cc182a2a783e072eabe44f536149">Plane</a> ()</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Default constructor - sets everything to 0.  <a href="#1530cc182a2a783e072eabe44f536149"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plane.html#1e298ca606c54a38ac5ea0df02282e62">Plane</a> (const <a class="el" href="classOgre_1_1Plane.html">Plane</a> &amp;rhs)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plane.html#296599d7461accceada20df86f7bd334">Plane</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;rkNormal, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> fConstant)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Construct a plane through a normal, and a distance to move the plane along the normal.  <a href="#296599d7461accceada20df86f7bd334"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plane.html#bd98e0aae4723943f83262e59cfda535">Plane</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;rkNormal, const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;rkPoint)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plane.html#f8000ad8fdef98bcc7e21a9d194547a0">Plane</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;rkPoint0, const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;rkPoint1, const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;rkPoint2)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Plane.html#a5d44b14d6f032f3e0a26e83589180bc">Side</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plane.html#e0131ee8cf1c09587c5cc4541c3b6297">getSide</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;rkPoint) const </td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Plane.html#a5d44b14d6f032f3e0a26e83589180bc">Side</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plane.html#b60532827d305cb7848f540be2cfb66b">getSide</a> (const <a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a> &amp;rkBox) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">returns the side where the aligneBox is.  <a href="#b60532827d305cb7848f540be2cfb66b"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Plane.html#a5d44b14d6f032f3e0a26e83589180bc">Side</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plane.html#a8a0b3abc05dcc47ef7ce79d98fb8a99">getSide</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;centre, const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;halfSize) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns which side of the plane that the given box lies on.  <a href="#a8a0b3abc05dcc47ef7ce79d98fb8a99"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plane.html#9548b13f88e65d98ea08ba01c8f2fad1">getDistance</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;rkPoint) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">This is a pseudodistance.  <a href="#9548b13f88e65d98ea08ba01c8f2fad1"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plane.html#3edb29b896bac43b3a199460123e94b2">redefine</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;rkPoint0, const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;rkPoint1, const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;rkPoint2)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Redefine this plane based on 3 points.  <a href="#3edb29b896bac43b3a199460123e94b2"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plane.html#74dab1f3fb059277cd477aa683b238f7">redefine</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;rkNormal, const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;rkPoint)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Redefine this plane based on a normal and a point.  <a href="#74dab1f3fb059277cd477aa683b238f7"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plane.html#54e83c81355e526a2b02d02625d42c4c">projectVector</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;v) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Project a vector onto the plane.  <a href="#54e83c81355e526a2b02d02625d42c4c"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plane.html#090aae792b4fecc6e8b1b5810f029edf">normalise</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Normalises the plane.  <a href="#090aae792b4fecc6e8b1b5810f029edf"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plane.html#06e8f4ea4698c322580c4299f6a12e07">operator==</a> (const <a class="el" href="classOgre_1_1Plane.html">Plane</a> &amp;rhs) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Comparison operator.  <a href="#06e8f4ea4698c322580c4299f6a12e07"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plane.html#dae7d1d5d43cbe44cd40fc1e86784268">operator!=</a> (const <a class="el" href="classOgre_1_1Plane.html">Plane</a> &amp;rhs) const </td></tr>

<tr><td colspan="2"><br><h2>Public Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plane.html#3f97462d3822f6add8c070048f6c2d92">normal</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plane.html#8e7de1712320968bee111002bc2938b8">d</a></td></tr>

<tr><td colspan="2"><br><h2>Friends</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">_OgreExport friend <br>
std::ostream &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plane.html#3a3cc401219af46e986952c5f6bc7959">operator&lt;&lt;</a> (std::ostream &amp;o, const <a class="el" href="classOgre_1_1Plane.html">Plane</a> &amp;p)</td></tr>

</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
Defines a plane in 3D space. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>A plane is defined in 3D space by the equation Ax + By + Cz + D = 0 </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>This equates to a vector (the normal of the plane, whose x, y and z components equate to the coefficients A, B and C respectively), and a constant (D) which is the distance along the normal you have to go to move the plane back to the origin. </dd></dl>

<p>Definition at line <a class="el" href="OgrePlane_8h-source.html#l00053">53</a> of file <a class="el" href="OgrePlane_8h-source.html">OgrePlane.h</a>.</p>
<hr><h2>Member Enumeration Documentation</h2>
<a class="anchor" name="a5d44b14d6f032f3e0a26e83589180bc"></a><!-- doxytag: member="Ogre::Plane::Side" ref="a5d44b14d6f032f3e0a26e83589180bc" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="classOgre_1_1Plane.html#a5d44b14d6f032f3e0a26e83589180bc">Ogre::Plane::Side</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
The "positive side" of the plane is the half space to which the plane normal points. 
<p>
The "negative side" is the other half space. The flag "no side" indicates the plane itself. <dl compact><dt><b>Enumerator: </b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td valign="top"><em><a class="anchor" name="a5d44b14d6f032f3e0a26e83589180bcad112821a6c39f0097136ba5df53052a"></a><!-- doxytag: member="NO_SIDE" ref="a5d44b14d6f032f3e0a26e83589180bcad112821a6c39f0097136ba5df53052a" args="" -->NO_SIDE</em>&nbsp;</td><td>
</td></tr>
<tr><td valign="top"><em><a class="anchor" name="a5d44b14d6f032f3e0a26e83589180bcc5f2b56ac439b77aad6dfc4031891be5"></a><!-- doxytag: member="POSITIVE_SIDE" ref="a5d44b14d6f032f3e0a26e83589180bcc5f2b56ac439b77aad6dfc4031891be5" args="" -->POSITIVE_SIDE</em>&nbsp;</td><td>
</td></tr>
<tr><td valign="top"><em><a class="anchor" name="a5d44b14d6f032f3e0a26e83589180bcaf227c36d02442779fd4600d00580f5e"></a><!-- doxytag: member="NEGATIVE_SIDE" ref="a5d44b14d6f032f3e0a26e83589180bcaf227c36d02442779fd4600d00580f5e" args="" -->NEGATIVE_SIDE</em>&nbsp;</td><td>
</td></tr>
<tr><td valign="top"><em><a class="anchor" name="a5d44b14d6f032f3e0a26e83589180bc44420e1c49338ae721f298826e164935"></a><!-- doxytag: member="BOTH_SIDE" ref="a5d44b14d6f032f3e0a26e83589180bc44420e1c49338ae721f298826e164935" args="" -->BOTH_SIDE</em>&nbsp;</td><td>
</td></tr>
</table>
</dl>

<p>Definition at line <a class="el" href="OgrePlane_8h-source.html#l00070">70</a> of file <a class="el" href="OgrePlane_8h-source.html">OgrePlane.h</a>.</p>

</div>
</div><p>
<hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="1530cc182a2a783e072eabe44f536149"></a><!-- doxytag: member="Ogre::Plane::Plane" ref="1530cc182a2a783e072eabe44f536149" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::Plane::Plane           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Default constructor - sets everything to 0. 
<p>

</div>
</div><p>
<a class="anchor" name="1e298ca606c54a38ac5ea0df02282e62"></a><!-- doxytag: member="Ogre::Plane::Plane" ref="1e298ca606c54a38ac5ea0df02282e62" args="(const Plane &amp;rhs)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::Plane::Plane           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Plane.html">Plane</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>rhs</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<a class="anchor" name="296599d7461accceada20df86f7bd334"></a><!-- doxytag: member="Ogre::Plane::Plane" ref="296599d7461accceada20df86f7bd334" args="(const Vector3 &amp;rkNormal, Real fConstant)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::Plane::Plane           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>rkNormal</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>fConstant</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Construct a plane through a normal, and a distance to move the plane along the normal. 
<p>

</div>
</div><p>
<a class="anchor" name="bd98e0aae4723943f83262e59cfda535"></a><!-- doxytag: member="Ogre::Plane::Plane" ref="bd98e0aae4723943f83262e59cfda535" args="(const Vector3 &amp;rkNormal, const Vector3 &amp;rkPoint)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::Plane::Plane           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>rkNormal</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>rkPoint</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<a class="anchor" name="f8000ad8fdef98bcc7e21a9d194547a0"></a><!-- doxytag: member="Ogre::Plane::Plane" ref="f8000ad8fdef98bcc7e21a9d194547a0" args="(const Vector3 &amp;rkPoint0, const Vector3 &amp;rkPoint1, const Vector3 &amp;rkPoint2)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::Plane::Plane           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>rkPoint0</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>rkPoint1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>rkPoint2</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="e0131ee8cf1c09587c5cc4541c3b6297"></a><!-- doxytag: member="Ogre::Plane::getSide" ref="e0131ee8cf1c09587c5cc4541c3b6297" args="(const Vector3 &amp;rkPoint) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Plane.html#a5d44b14d6f032f3e0a26e83589180bc">Side</a> Ogre::Plane::getSide           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>rkPoint</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Referenced by <a class="el" href="OgrePlaneBoundedVolume_8h-source.html#l00059">Ogre::PlaneBoundedVolume::intersects()</a>.</p>

</div>
</div><p>
<a class="anchor" name="b60532827d305cb7848f540be2cfb66b"></a><!-- doxytag: member="Ogre::Plane::getSide" ref="b60532827d305cb7848f540be2cfb66b" args="(const AxisAlignedBox &amp;rkBox) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Plane.html#a5d44b14d6f032f3e0a26e83589180bc">Side</a> Ogre::Plane::getSide           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>rkBox</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
returns the side where the aligneBox is. 
<p>
the flag BOTH_SIDE indicates an intersecting box. one corner ON the plane is sufficient to consider the box and the plane intersecting. 
</div>
</div><p>
<a class="anchor" name="a8a0b3abc05dcc47ef7ce79d98fb8a99"></a><!-- doxytag: member="Ogre::Plane::getSide" ref="a8a0b3abc05dcc47ef7ce79d98fb8a99" args="(const Vector3 &amp;centre, const Vector3 &amp;halfSize) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Plane.html#a5d44b14d6f032f3e0a26e83589180bc">Side</a> Ogre::Plane::getSide           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>centre</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>halfSize</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns which side of the plane that the given box lies on. 
<p>
The box is defined as centre/half-size pairs for effectively. <dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>centre</em>&nbsp;</td><td>The centre of the box. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>halfSize</em>&nbsp;</td><td>The half-size of the box. </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>POSITIVE_SIDE if the box complete lies on the "positive side" of the plane, NEGATIVE_SIDE if the box complete lies on the "negative side" of the plane, and BOTH_SIDE if the box intersects the plane. </dd></dl>

</div>
</div><p>
<a class="anchor" name="9548b13f88e65d98ea08ba01c8f2fad1"></a><!-- doxytag: member="Ogre::Plane::getDistance" ref="9548b13f88e65d98ea08ba01c8f2fad1" args="(const Vector3 &amp;rkPoint) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> Ogre::Plane::getDistance           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>rkPoint</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
This is a pseudodistance. 
<p>
The sign of the return value is positive if the point is on the positive side of the plane, negative if the point is on the negative side, and zero if the point is on the plane. <dl class="user" compact><dt><b></b></dt><dd>The absolute value of the return value is the true distance only when the plane normal is a unit length vector. </dd></dl>

<p>Referenced by <a class="el" href="OgrePlaneBoundedVolume_8h-source.html#l00090">Ogre::PlaneBoundedVolume::intersects()</a>.</p>

</div>
</div><p>
<a class="anchor" name="3edb29b896bac43b3a199460123e94b2"></a><!-- doxytag: member="Ogre::Plane::redefine" ref="3edb29b896bac43b3a199460123e94b2" args="(const Vector3 &amp;rkPoint0, const Vector3 &amp;rkPoint1, const Vector3 &amp;rkPoint2)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::Plane::redefine           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>rkPoint0</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>rkPoint1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>rkPoint2</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Redefine this plane based on 3 points. 
<p>

</div>
</div><p>
<a class="anchor" name="74dab1f3fb059277cd477aa683b238f7"></a><!-- doxytag: member="Ogre::Plane::redefine" ref="74dab1f3fb059277cd477aa683b238f7" args="(const Vector3 &amp;rkNormal, const Vector3 &amp;rkPoint)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::Plane::redefine           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>rkNormal</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>rkPoint</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Redefine this plane based on a normal and a point. 
<p>

</div>
</div><p>
<a class="anchor" name="54e83c81355e526a2b02d02625d42c4c"></a><!-- doxytag: member="Ogre::Plane::projectVector" ref="54e83c81355e526a2b02d02625d42c4c" args="(const Vector3 &amp;v) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a> Ogre::Plane::projectVector           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>v</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Project a vector onto the plane. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>This gives you the element of the input vector that is perpendicular to the normal of the plane. You can get the element which is parallel to the normal of the plane by subtracting the result of this method from the original vector, since parallel + perpendicular = original. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>v</em>&nbsp;</td><td>The input vector </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="090aae792b4fecc6e8b1b5810f029edf"></a><!-- doxytag: member="Ogre::Plane::normalise" ref="090aae792b4fecc6e8b1b5810f029edf" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> Ogre::Plane::normalise           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Normalises the plane. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>This method normalises the plane's normal and the length scale of d is as well. </dd></dl>
<dl class="note" compact><dt><b>Note:</b></dt><dd>This function will not crash for zero-sized vectors, but there will be no changes made to their components. </dd></dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>The previous length of the plane's normal. </dd></dl>

</div>
</div><p>
<a class="anchor" name="06e8f4ea4698c322580c4299f6a12e07"></a><!-- doxytag: member="Ogre::Plane::operator==" ref="06e8f4ea4698c322580c4299f6a12e07" args="(const Plane &amp;rhs) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::Plane::operator==           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Plane.html">Plane</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>rhs</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Comparison operator. 
<p>

<p>Definition at line <a class="el" href="OgrePlane_8h-source.html#l00138">138</a> of file <a class="el" href="OgrePlane_8h-source.html">OgrePlane.h</a>.</p>

<p>References <a class="el" href="OgrePlane_8h-source.html#l00135">d</a>, and <a class="el" href="OgrePlane_8h-source.html#l00134">normal</a>.</p>

</div>
</div><p>
<a class="anchor" name="dae7d1d5d43cbe44cd40fc1e86784268"></a><!-- doxytag: member="Ogre::Plane::operator!=" ref="dae7d1d5d43cbe44cd40fc1e86784268" args="(const Plane &amp;rhs) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::Plane::operator!=           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Plane.html">Plane</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>rhs</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgrePlane_8h-source.html#l00142">142</a> of file <a class="el" href="OgrePlane_8h-source.html">OgrePlane.h</a>.</p>

<p>References <a class="el" href="OgrePlane_8h-source.html#l00135">d</a>, and <a class="el" href="OgrePlane_8h-source.html#l00134">normal</a>.</p>

</div>
</div><p>
<hr><h2>Friends And Related Function Documentation</h2>
<a class="anchor" name="3a3cc401219af46e986952c5f6bc7959"></a><!-- doxytag: member="Ogre::Plane::operator&lt;&lt;" ref="3a3cc401219af46e986952c5f6bc7959" args="(std::ostream &amp;o, const Plane &amp;p)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">_OgreExport friend std::ostream&amp; operator&lt;&lt;           </td>
          <td>(</td>
          <td class="paramtype">std::ostream &amp;&nbsp;</td>
          <td class="paramname"> <em>o</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Plane.html">Plane</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>p</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [friend]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<hr><h2>Member Data Documentation</h2>
<a class="anchor" name="3f97462d3822f6add8c070048f6c2d92"></a><!-- doxytag: member="Ogre::Plane::normal" ref="3f97462d3822f6add8c070048f6c2d92" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a> <a class="el" href="classOgre_1_1Plane.html#3f97462d3822f6add8c070048f6c2d92">Ogre::Plane::normal</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgrePlane_8h-source.html#l00134">134</a> of file <a class="el" href="OgrePlane_8h-source.html">OgrePlane.h</a>.</p>

<p>Referenced by <a class="el" href="OgreMatrix4_8h-source.html#l00210">Ogre::Matrix4::operator *()</a>, <a class="el" href="OgrePlane_8h-source.html#l00142">operator!=()</a>, and <a class="el" href="OgrePlane_8h-source.html#l00138">operator==()</a>.</p>

</div>
</div><p>
<a class="anchor" name="8e7de1712320968bee111002bc2938b8"></a><!-- doxytag: member="Ogre::Plane::d" ref="8e7de1712320968bee111002bc2938b8" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> <a class="el" href="classOgre_1_1Plane.html#8e7de1712320968bee111002bc2938b8">Ogre::Plane::d</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgrePlane_8h-source.html#l00135">135</a> of file <a class="el" href="OgrePlane_8h-source.html">OgrePlane.h</a>.</p>

<p>Referenced by <a class="el" href="OgreMatrix4_8h-source.html#l00210">Ogre::Matrix4::operator *()</a>, <a class="el" href="OgrePlane_8h-source.html#l00142">operator!=()</a>, and <a class="el" href="OgrePlane_8h-source.html#l00138">operator==()</a>.</p>

</div>
</div><p>
<hr>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgrePlane_8h-source.html">OgrePlane.h</a></ul>
<hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:51:48 2008
</p>
</body>
</html>
